# HyLAR client-side demo howto

## Startup

#### Install HyLAR using Bower: `bower install hylar`

Remember: doc is here: https://github.com/ucbl/hylar-reasoner#supported-inferences

## Basic example (with SOSA / SSN)

#### SSN ontologies:
./ontologies/sosa.ttl
./ontologies/ssn.ttl

#### SSN instances:
Choose any of the examples from https://github.com/w3c/sdw/tree/gh-pages/ssn/integrated/examples
To get the file contents, you must request the raw files (URLs starting with https://raw.githubusercontent.com/w3c/sdw/gh-pages/ssn/integrated/examples/)

You can also load them locally from [./ontologies/ssn_examples](./ontologies/ssn_examples).

#### SSN query:
`SELECT * { ?s <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> <hhttp://www.w3.org/ns/ssn/System> . } limit 10`

#### Additional rule:
`(?c1 http://www.w3.org/1999/02/22-rdf-syntax-ns#type ?c2) ^ (?c3 http://www.w3.org/1999/02/22-rdf-syntax-ns#type ?c2) -> (?c1 http://asawoo.liris.cnrs.fr#isSomehowRelatedTo ?c3)`

#### Business query:
`SELECT * { ?s <http://asawoo.liris.cnrs.fr#isSomehowRelatedTo> ?o . } limit 10`

#### Other query example:
`CONSTRUCT { 
  ?i1 <http://asawoo.liris.cnrs.fr#isSomehowRelatedTo> ?i2 .
  ?i2 <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> ?c .
}
WHERE { 
  ?i1 <http://asawoo.liris.cnrs.fr#isSomehowRelatedTo> ?i2 .
  ?i1 <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> ?c .
  ?i2 <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> ?c .
} LIMIT 1`

## Mapping SSN / WoT:

1) Load SOSA, SSN and WoT ontologies (classes only)
2) Insert mapping between sosa#Platform and wot#Thing:

`INSERT  DATA {<http://www.w3.org/ns/sosa/Platform> <http://www.w3.org/2000/01/rdf-schema#subClassOf> <http://iot.linkeddata.es/def/wot#Thing> .}`

3) Insert SSN instances (cf. before)
4) Query wot#Thing instances

`SELECT * {
 ?thing <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> <http://iot.linkeddata.es/def/wot#Thing> .
 ?thing <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> ?type .
} limit 10`

## Potential issues:

- CORS issues while retrieving the files on different servers: make sure you are running this demo from a web server, so that your browser can send CORS headers. If the server you are trying to contact is not CORS-enabled, copy the text of the turtle file in a file on your own server.
- The Turtle mime type is hardcoded and the server serves an HTML page instead of turtle: copy the text of the turtle file in a file on your own server.
- Newly added rules are not taken into account: as HyLAR is an incremental reasoner, adding a rule does not modify the knowledge base; you must reload the data in order to have them processed using your new rule(s).
